gi-gtk-3.0.43: Gtk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Interfaces.TreeModel

Contents

- Exported types
- Methods
  - filterNew
  - foreach
  - getColumnType
  - getFlags
  - getIter
  - getIterFirst
  - getIterFromString
  - getNColumns
  - getPath
  - getStringFromIter
  - getValue
  - iterChildren
  - iterHasChild
  - iterNChildren
  - iterNext
  - iterNthChild
  - iterParent
  - iterPrevious
  - refNode
  - rowChanged
  - rowDeleted
  - rowHasChildToggled
  - rowInserted
  - rowsReordered
  - unrefNode
- Signals
  - rowChanged
  - rowDeleted
  - rowHasChildToggled
  - rowInserted

Description

The `TreeModel` interface defines a generic tree interface for use by the `TreeView` widget. It is an abstract interface, and is designed to be usable with any appropriate data structure. The programmer just has to implement this interface on their own data type for it to be viewable by a `TreeView` widget.

The model is represented as a hierarchical tree of strongly-typed, columned data. In other words, the model can be seen as a tree where every node has different values depending on which column is being queried. The type of data found in a column is determined by using the GType system (ie. `G_TYPE_INT`, `GTK_TYPE_BUTTON`, `G_TYPE_POINTER`, etc). The types are homogeneous per column across all nodes. It is important to note that this interface only provides a way of examining a model and observing changes. The implementation of each individual model decides how and if changes are made.

In order to make life simpler for programmers who do not need to write their own specialized model, two generic models are provided — the `TreeStore` and the `ListStore`. To use these, the developer simply pushes data into these models as necessary. These models provide the data structure as well as all appropriate tree interfaces. As a result, implementing drag and drop, sorting, and storing data is trivial. For the vast majority of trees and lists, these two models are sufficient.

Models are accessed on a node/column level of granularity. One can query for the value of a model at a certain node and a certain column on that node. There are two structures used to reference a particular node in a model. They are the `TreePath`-struct and the `TreeIter`-struct (“iter” is short for iterator). Most of the interface consists of operations on a `TreeIter`-struct.

A path is essentially a potential node. It is a location on a model that may or may not actually correspond to a node on a specific model. The `TreePath`-struct can be converted into either an array of unsigned integers or a string. The string form is a list of numbers separated by a colon. Each number refers to the offset at that level. Thus, the path `0` refers to the root node and the path `2:4` refers to the fifth child of the third node.

By contrast, a `TreeIter`-struct is a reference to a specific node on a specific model. It is a generic struct with an integer and three generic pointers. These are filled in by the model in a model-specific way. One can convert a path to an iterator by calling `treeModelGetIter`. These iterators are the primary way of accessing a model and are similar to the iterators used by `TextBuffer`. They are generally statically allocated on the stack and only used for a short time. The model interface defines a set of operations using them for navigating the model.

It is expected that models fill in the iterator with private data. For example, the `ListStore` model, which is internally a simple linked list, stores a list node in one of the pointers. The `TreeModelSort` stores an array and an offset in two of the pointers. Additionally, there is an integer field. This field is generally filled with a unique stamp per model. This stamp is for catching errors resulting from using invalid iterators with a model.

The lifecycle of an iterator can be a little confusing at first. Iterators are expected to always be valid for as long as the model is unchanged (and doesn’t emit a signal). The model is considered to own all outstanding iterators and nothing needs to be done to free them from the user’s point of view. Additionally, some models guarantee that an iterator is valid for as long as the node it refers to is valid (most notably the `TreeStore` and `ListStore`). Although generally uninteresting, as one always has to allow for the case where iterators do not persist beyond a signal, some very important performance enhancements were made in the sort model. As a result, the `GTK_TREE_MODEL_ITERS_PERSIST` flag was added to indicate this behavior.

To help show some common operation of a model, some examples are provided. The first example shows three ways of getting the iter at the location `3:2:5`. While the first method shown is easier, the second is much more common, as you often get paths from callbacks.

## Acquiring a `TreeIter`-struct

### C code

    // Three ways of getting the iter pointing to the location
    GtkTreePath *path;
    GtkTreeIter iter;
    GtkTreeIter parent_iter;

    // get the iterator from a string
    gtk_tree_model_get_iter_from_string (model,
                                         &iter,
                                         "3:2:5");

    // get the iterator from a path
    path = gtk_tree_path_new_from_string ("3:2:5");
    gtk_tree_model_get_iter (model, &iter, path);
    gtk_tree_path_free (path);

    // walk the tree to find the iterator
    gtk_tree_model_iter_nth_child (model, &iter,
                                   NULL, 3);
    parent_iter = iter;
    gtk_tree_model_iter_nth_child (model, &iter,
                                   &parent_iter, 2);
    parent_iter = iter;
    gtk_tree_model_iter_nth_child (model, &iter,
                                   &parent_iter, 5);

This second example shows a quick way of iterating through a list and getting a string and an integer from each row. The `populate_model()` function used below is not shown, as it is specific to the `ListStore`. For information on how to write such a function, see the `ListStore` documentation.

## Reading data from a `TreeModel`

### C code

    enum
    {
      STRING_COLUMN,
      INT_COLUMN,
      N_COLUMNS
    };

    ...

    GtkTreeModel *list_store;
    GtkTreeIter iter;
    gboolean valid;
    gint row_count = 0;

    // make a new list_store
    list_store = gtk_list_store_new (N_COLUMNS,
                                     G_TYPE_STRING,
                                     G_TYPE_INT);

    // Fill the list store with data
    populate_model (list_store);

    // Get the first iter in the list, check it is valid and walk
    // through the list, reading each row.

    valid = gtk_tree_model_get_iter_first (list_store,
                                           &iter);
    while (valid)
     {
       gchar *str_data;
       gint   int_data;

       // Make sure you terminate calls to gtk_tree_model_get() with a “-1” value
       gtk_tree_model_get (list_store, &iter,
                           STRING_COLUMN, &str_data,
                           INT_COLUMN, &int_data,
                           -1);

       // Do something with the data
       g_print ("Row %d: (%s,%d)\n",
                row_count, str_data, int_data);
       g_free (str_data);

       valid = gtk_tree_model_iter_next (list_store,
                                         &iter);
       row_count++;
     }

The `TreeModel` interface contains two methods for reference counting: `treeModelRefNode` and `treeModelUnrefNode`. These two methods are optional to implement. The reference counting is meant as a way for views to let models know when nodes are being displayed. `TreeView` will take a reference on a node when it is visible, which means the node is either in the toplevel or expanded. Being displayed does not mean that the node is currently directly visible to the user in the viewport. Based on this reference counting scheme a caching model, for example, can decide whether or not to cache a node based on the reference count. A file-system based model would not want to keep the entire file hierarchy in memory, but just the folders that are currently expanded in every current view.

When working with reference counting, the following rules must be taken into account:

- Never take a reference on a node without owning a reference on its parent. This means that all parent nodes of a referenced node must be referenced as well.
- Outstanding references on a deleted node are not released. This is not possible because the node has already been deleted by the time the row-deleted signal is received.
- Models are not obligated to emit a signal on rows of which none of its siblings are referenced. To phrase this differently, signals are only required for levels in which nodes are referenced. For the root level however, signals must be emitted at all times (however the root level is always referenced when any view is attached).

Synopsis

- newtype TreeModel = TreeModel (ManagedPtr TreeModel)
- class (GObject o, IsDescendantOf TreeModel o) => IsTreeModel o
- toTreeModel :: (MonadIO m, IsTreeModel o) => o -> m TreeModel
- treeModelFilterNew :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> Maybe TreePath -> m TreeModel
- treeModelForeach :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreeModelForeachFunc -> m ()
- treeModelGetColumnType :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> Int32 -> m GType
- treeModelGetFlags :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> m [TreeModelFlags]
- treeModelGetIter :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreePath -> m (Bool, TreeIter)
- treeModelGetIterFirst :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> m (Bool, TreeIter)
- treeModelGetIterFromString :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> Text -> m (Bool, TreeIter)
- treeModelGetNColumns :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> m Int32
- treeModelGetPath :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreeIter -> m TreePath
- treeModelGetStringFromIter :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreeIter -> m Text
- treeModelGetValue :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreeIter -> Int32 -> m GValue
- treeModelIterChildren :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> Maybe TreeIter -> m (Bool, TreeIter)
- treeModelIterHasChild :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreeIter -> m Bool
- treeModelIterNChildren :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> Maybe TreeIter -> m Int32
- treeModelIterNext :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreeIter -> m Bool
- treeModelIterNthChild :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> Maybe TreeIter -> Int32 -> m (Bool, TreeIter)
- treeModelIterParent :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreeIter -> m (Bool, TreeIter)
- treeModelIterPrevious :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreeIter -> m Bool
- treeModelRefNode :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreeIter -> m ()
- treeModelRowChanged :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreePath -> TreeIter -> m ()
- treeModelRowDeleted :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreePath -> m ()
- treeModelRowHasChildToggled :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreePath -> TreeIter -> m ()
- treeModelRowInserted :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreePath -> TreeIter -> m ()
- treeModelRowsReordered :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreePath -> Maybe TreeIter -> [Int32] -> m ()
- treeModelUnrefNode :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> TreeIter -> m ()
- type TreeModelRowChangedCallback = TreePath -> TreeIter -> IO ()
- afterTreeModelRowChanged :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowChangedCallback) -> m SignalHandlerId
- onTreeModelRowChanged :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowChangedCallback) -> m SignalHandlerId
- type TreeModelRowDeletedCallback = TreePath -> IO ()
- afterTreeModelRowDeleted :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowDeletedCallback) -> m SignalHandlerId
- onTreeModelRowDeleted :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowDeletedCallback) -> m SignalHandlerId
- type TreeModelRowHasChildToggledCallback = TreePath -> TreeIter -> IO ()
- afterTreeModelRowHasChildToggled :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowHasChildToggledCallback) -> m SignalHandlerId
- onTreeModelRowHasChildToggled :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowHasChildToggledCallback) -> m SignalHandlerId
- type TreeModelRowInsertedCallback = TreePath -> TreeIter -> IO ()
- afterTreeModelRowInserted :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowInsertedCallback) -> m SignalHandlerId
- onTreeModelRowInserted :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowInsertedCallback) -> m SignalHandlerId

# Exported types

newtype TreeModel Source #

Memory-managed wrapper type.

Constructors

TreeModel (ManagedPtr TreeModel) |

#### Instances

Instances details

Eq TreeModel Source # |
Instance details Defined in GI.Gtk.Interfaces.TreeModel Methods (==) :: TreeModel -> TreeModel -> Bool Source # (/=) :: TreeModel -> TreeModel -> Bool Source #
GObject TreeModel Source # |
Instance details Defined in GI.Gtk.Interfaces.TreeModel
ManagedPtrNewtype TreeModel Source # |
Instance details Defined in GI.Gtk.Interfaces.TreeModel Methods toManagedPtr :: TreeModel -> ManagedPtr TreeModel Source #
TypedObject TreeModel Source # |
Instance details Defined in GI.Gtk.Interfaces.TreeModel Methods glibType :: IO GType Source #
HasParentTypes TreeModel Source # |
Instance details Defined in GI.Gtk.Interfaces.TreeModel
IsGValue (Maybe TreeModel) Source # | Convert `TreeModel` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Interfaces.TreeModel Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe TreeModel -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe TreeModel) Source #
type ParentTypes TreeModel Source # |
Instance details Defined in GI.Gtk.Interfaces.TreeModel type ParentTypes TreeModel = '[Object]

class (GObject o, IsDescendantOf TreeModel o) => IsTreeModel o Source #

Type class for types which can be safely cast to `TreeModel`, for instance with `toTreeModel`.

#### Instances

Instances details

(GObject o, IsDescendantOf TreeModel o) => IsTreeModel o Source # |
Instance details Defined in GI.Gtk.Interfaces.TreeModel

toTreeModel :: (MonadIO m, IsTreeModel o) => o -> m TreeModel Source #

Cast to `TreeModel`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, filterNew, forceFloating, foreach, freezeNotify, getv, isFloating, iterChildren, iterHasChild, iterNChildren, iterNext, iterNthChild, iterParent, iterPrevious, notify, notifyByPspec, ref, refNode, refSink, rowChanged, rowDeleted, rowHasChildToggled, rowInserted, rowsReordered, runDispose, stealData, stealQdata, thawNotify, unref, unrefNode, watchClosure.

#### Getters

getColumnType, getData, getFlags, getIter, getIterFirst, getIterFromString, getNColumns, getPath, getProperty, getQdata, getStringFromIter, getValue.

#### Setters

setData, setDataFull, setProperty.

## filterNew

treeModelFilterNew Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `childModel`: A `TreeModel`.
-> Maybe TreePath | `root`: A `TreePath` or `Nothing`.
-> m TreeModel | Returns: A new `TreeModel`.

Creates a new `TreeModel`, with `childModel` as the child_model and `root` as the virtual root.

Since: 2.4

## foreach

treeModelForeach Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `model`: a `TreeModel`
-> TreeModelForeachFunc | `func`: a function to be called on each row
-> m () |

Calls func on each node in model in a depth-first fashion.

If `func` returns `True`, then the tree ceases to be walked, and `treeModelForeach` returns.

## getColumnType

treeModelGetColumnType Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> Int32 | `index_`: the column index
-> m GType | Returns: the type of the column

Returns the type of the column.

## getFlags

treeModelGetFlags Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> m [TreeModelFlags] | Returns: the flags supported by this interface

Returns a set of flags supported by this interface.

The flags are a bitwise combination of `TreeModelFlags`. The flags supported should not change during the lifetime of the `treeModel`.

## getIter

treeModelGetIter Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreePath | `path`: the `TreePath`-struct
-> m (Bool, TreeIter) | Returns: `True`, if `iter` was set

Sets `iter` to a valid iterator pointing to `path`. If `path` does not exist, `iter` is set to an invalid iterator and `False` is returned.

## getIterFirst

treeModelGetIterFirst Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> m (Bool, TreeIter) | Returns: `True`, if `iter` was set

Initializes `iter` with the first iterator in the tree (the one at the path "0") and returns `True`. Returns `False` if the tree is empty.

## getIterFromString

treeModelGetIterFromString Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> Text | `pathString`: a string representation of a `TreePath`-struct
-> m (Bool, TreeIter) | Returns: `True`, if `iter` was set

Sets `iter` to a valid iterator pointing to `pathString`, if it exists. Otherwise, `iter` is left invalid and `False` is returned.

## getNColumns

treeModelGetNColumns Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> m Int32 | Returns: the number of columns

Returns the number of columns supported by `treeModel`.

## getPath

treeModelGetPath Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreeIter | `iter`: the `TreeIter`-struct
-> m TreePath | Returns: a newly-created `TreePath`-struct

Returns a newly-created `TreePath`-struct referenced by `iter`.

This path should be freed with `treePathFree`.

## getStringFromIter

treeModelGetStringFromIter Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreeIter | `iter`: a `TreeIter`-struct
-> m Text | Returns: a newly-allocated string. Must be freed with `free`.

Generates a string representation of the iter.

This string is a “:” separated list of numbers. For example, “4:10:0:3” would be an acceptable return value for this string.

Since: 2.2

## getValue

treeModelGetValue Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreeIter | `iter`: the `TreeIter`-struct
-> Int32 | `column`: the column to lookup the value at
-> m GValue |

Initializes and sets `value` to that at `column`.

When done with `value`, `valueUnset` needs to be called to free any allocated memory.

## iterChildren

treeModelIterChildren Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> Maybe TreeIter | `parent`: the `TreeIter`-struct, or `Nothing`
-> m (Bool, TreeIter) | Returns: `True`, if `iter` has been set to the first child

Sets `iter` to point to the first child of `parent`.

If `parent` has no children, `False` is returned and `iter` is set to be invalid. `parent` will remain a valid node after this function has been called.

If `parent` is `Nothing` returns the first node, equivalent to `gtk_tree_model_get_iter_first (tree_model, iter);`

## iterHasChild

treeModelIterHasChild Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreeIter | `iter`: the `TreeIter`-struct to test for children
-> m Bool | Returns: `True` if `iter` has children

Returns `True` if `iter` has children, `False` otherwise.

## iterNChildren

treeModelIterNChildren Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> Maybe TreeIter | `iter`: the `TreeIter`-struct, or `Nothing`
-> m Int32 | Returns: the number of children of `iter`

Returns the number of children that `iter` has.

As a special case, if `iter` is `Nothing`, then the number of toplevel nodes is returned.

## iterNext

treeModelIterNext Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreeIter | `iter`: the `TreeIter`-struct
-> m Bool | Returns: `True` if `iter` has been changed to the next node

Sets `iter` to point to the node following it at the current level.

If there is no next `iter`, `False` is returned and `iter` is set to be invalid.

## iterNthChild

treeModelIterNthChild Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> Maybe TreeIter | `parent`: the `TreeIter`-struct to get the child from, or `Nothing`.
-> Int32 | `n`: the index of the desired child
-> m (Bool, TreeIter) | Returns: `True`, if `parent` has an `n`-th child

Sets `iter` to be the child of `parent`, using the given index.

The first index is 0. If `n` is too big, or `parent` has no children, `iter` is set to an invalid iterator and `False` is returned. `parent` will remain a valid node after this function has been called. As a special case, if `parent` is `Nothing`, then the `n`-th root node is set.

## iterParent

treeModelIterParent Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreeIter | `child`: the `TreeIter`-struct
-> m (Bool, TreeIter) | Returns: `True`, if `iter` is set to the parent of `child`

Sets `iter` to be the parent of `child`.

If `child` is at the toplevel, and doesn’t have a parent, then `iter` is set to an invalid iterator and `False` is returned. `child` will remain a valid node after this function has been called.

`iter` will be initialized before the lookup is performed, so `child` and `iter` cannot point to the same memory location.

## iterPrevious

treeModelIterPrevious Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreeIter | `iter`: the `TreeIter`-struct
-> m Bool | Returns: `True` if `iter` has been changed to the previous node

Sets `iter` to point to the previous node at the current level.

If there is no previous `iter`, `False` is returned and `iter` is set to be invalid.

Since: 3.0

## refNode

treeModelRefNode Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreeIter | `iter`: the `TreeIter`-struct
-> m () |

Lets the tree ref the node.

This is an optional method for models to implement. To be more specific, models may ignore this call as it exists primarily for performance reasons.

This function is primarily meant as a way for views to let caching models know when nodes are being displayed (and hence, whether or not to cache that node). Being displayed means a node is in an expanded branch, regardless of whether the node is currently visible in the viewport. For example, a file-system based model would not want to keep the entire file-hierarchy in memory, just the sections that are currently being displayed by every current view.

A model should be expected to be able to get an iter independent of its reffed state.

## rowChanged

treeModelRowChanged Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreePath | `path`: a `TreePath`-struct pointing to the changed row
-> TreeIter | `iter`: a valid `TreeIter`-struct pointing to the changed row
-> m () |

Emits the TreeModel::rowChanged signal on `treeModel`.

## rowDeleted

treeModelRowDeleted Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreePath | `path`: a `TreePath`-struct pointing to the previous location of the deleted row
-> m () |

Emits the TreeModel::rowDeleted signal on `treeModel`.

This should be called by models after a row has been removed. The location pointed to by `path` should be the location that the row previously was at. It may not be a valid location anymore.

Nodes that are deleted are not unreffed, this means that any outstanding references on the deleted node should not be released.

## rowHasChildToggled

treeModelRowHasChildToggled Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreePath | `path`: a `TreePath`-struct pointing to the changed row
-> TreeIter | `iter`: a valid `TreeIter`-struct pointing to the changed row
-> m () |

Emits the TreeModel::rowHasChildToggled signal on `treeModel`. This should be called by models after the child state of a node changes.

## rowInserted

treeModelRowInserted Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreePath | `path`: a `TreePath`-struct pointing to the inserted row
-> TreeIter | `iter`: a valid `TreeIter`-struct pointing to the inserted row
-> m () |

Emits the TreeModel::rowInserted signal on `treeModel`.

## rowsReordered

treeModelRowsReordered Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreePath | `path`: a `TreePath`-struct pointing to the tree node whose children have been reordered
-> Maybe TreeIter | `iter`: a valid `TreeIter`-struct pointing to the node whose children have been reordered, or `Nothing` if the depth of `path` is 0
-> [Int32] | `newOrder`: an array of integers mapping the current position of each child to its old position before the re-ordering, i.e. `newOrder``[newpos] = oldpos`
-> m () |

Emits the `TreeModel`::`rows-reordered` signal on `treeModel`.

This should be called by models when their rows have been reordered.

Since: 3.10

## unrefNode

treeModelUnrefNode Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `treeModel`: a `TreeModel`
-> TreeIter | `iter`: the `TreeIter`-struct
-> m () |

Lets the tree unref the node.

This is an optional method for models to implement. To be more specific, models may ignore this call as it exists primarily for performance reasons. For more information on what this means, see `treeModelRefNode`.

Please note that nodes that are deleted are not unreffed.

# Signals

## rowChanged

type TreeModelRowChangedCallback Source #

Arguments

= TreePath | `path`: a `TreePath`-struct identifying the changed row
-> TreeIter | `iter`: a valid `TreeIter`-struct pointing to the changed row
-> IO () |

This signal is emitted when a row in the model has changed.

afterTreeModelRowChanged :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the rowChanged signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after treeModel #rowChanged callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onTreeModelRowChanged :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the rowChanged signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on treeModel #rowChanged callback

## rowDeleted

type TreeModelRowDeletedCallback Source #

Arguments

= TreePath | `path`: a `TreePath`-struct identifying the row
-> IO () |

This signal is emitted when a row has been deleted.

Note that no iterator is passed to the signal handler, since the row is already deleted.

This should be called by models after a row has been removed. The location pointed to by `path` should be the location that the row previously was at. It may not be a valid location anymore.

afterTreeModelRowDeleted :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowDeletedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the rowDeleted signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after treeModel #rowDeleted callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onTreeModelRowDeleted :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowDeletedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the rowDeleted signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on treeModel #rowDeleted callback

## rowHasChildToggled

type TreeModelRowHasChildToggledCallback Source #

Arguments

= TreePath | `path`: a `TreePath`-struct identifying the row
-> TreeIter | `iter`: a valid `TreeIter`-struct pointing to the row
-> IO () |

This signal is emitted when a row has gotten the first child row or lost its last child row.

afterTreeModelRowHasChildToggled :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowHasChildToggledCallback) -> m SignalHandlerId Source #

Connect a signal handler for the rowHasChildToggled signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after treeModel #rowHasChildToggled callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onTreeModelRowHasChildToggled :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowHasChildToggledCallback) -> m SignalHandlerId Source #

Connect a signal handler for the rowHasChildToggled signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on treeModel #rowHasChildToggled callback

## rowInserted

type TreeModelRowInsertedCallback Source #

Arguments

= TreePath | `path`: a `TreePath`-struct identifying the new row
-> TreeIter | `iter`: a valid `TreeIter`-struct pointing to the new row
-> IO () |

This signal is emitted when a new row has been inserted in the model.

Note that the row may still be empty at this point, since it is a common pattern to first insert an empty row, and then fill it with the desired values.

afterTreeModelRowInserted :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowInsertedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the rowInserted signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after treeModel #rowInserted callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onTreeModelRowInserted :: (IsTreeModel a, MonadIO m) => a -> ((?self :: a) => TreeModelRowInsertedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the rowInserted signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on treeModel #rowInserted callback